#!/usr/bin/perl -i -p

my $o4w32 = $ENV{O4W_32};
my $o4w64 = $ENV{O4W_64};
my $pwd = $ENV{PWD};

if(/<AdditionalIncludeDirectories>/) {
	s#\$\(GDAL(_32)?\)[\\/]port;##gn;
	s#\$\(GDAL(_32)?\)[\\/]ogr;##gn;
	s#\$\(GDAL(_32)?\)[\\/]ogr[\\/]ogrsf_frmts;##gn;

	s#\$\(GDAL_32\)[\\/]include#$o4w32/include#gn;
	s#\$\(GDAL\)[\\/]include#$o4w64/include#gn;

	s#\$\(PROJ4_32\);#$o4w32/include;#gn;
	s#\$\(PROJ4\);#$o4w64/include;#gn;

	s#\$\(PGSQL_32\)[\\/]include#$o4w32/include#gn;
	s#\$\(PGSQL\)[\\/]include#$o4w64/include#gn;

	s#\$\(HARU_32\)[\\/]include#$pwd/libharu-RELEASE_2_3_0/include#gn;
	s#\$\(HARU\)[\\/]include#$pwd/libharu-RELEASE_2_3_0/include#gn;

	s#\$\(LIBLAS_32\)[\\/]include#$o4w32/include;$o4w32/include/boost-1_56#gn;
	s#\$\(LIBLAS\)[\\/]include#$o4w64/include;$o4w64/include/boost-1_55#gn;

	s#\$\(OPENCV_32\)[\\/]include#$o4w32/include#gn;
	s#\$\(OPENCV\)[\\/]include#$o4w64/include#gn;

	s#\$\(VIGRA_32\)[\\/]include#$o4w32/include#gn;
	s#\$\(VIGRA\)[\\/]include#$o4w64/include#gn;

	s#\$\(WXWIN(_32)?\)[\\/]include#$pwd/include#gn;

	s#\$\(WXWIN(_32)?\)[\\/]lib[\\/]vc_dll#$pwd/lib/vc140_dll#gn;
	s#\$\(WXWIN\)[\\/]lib[\\/]vc_x64_dll#$pwd/lib/vc140_x64_dll#gn;

	s#;+#;#g;
} elsif(/<AdditionalLibraryDirectories>/) {
	s#\$\(GDAL_32\)[\\/]lib#$o4w32/lib#gn;
	s#\$\(GDAL\)[\\/]lib#$o4w64/lib#gn;

	s#\$\(PROJ4_32\);#$o4w32/lib;#gn;
	s#\$\(PROJ4\);#$o4w64/lib;#gn;

	s#\$\(PGSQL_32\)[\\/]lib#$o4w32/lib;#gn;
	s#\$\(PGSQL\)[\\/]lib#$o4w64/lib;#gn;

	s#\$\(LIBLAS_32\)[\\/]lib#$o4w32/lib#gn;
	s#\$\(LIBLAS\)[\\/]lib#$o4w64/lib#gn;

	s#\$\(OPENCV_32\)[\\/]lib#$o4w32/lib#gn;
	s#\$\(OPENCV\)[\\/]lib#$o4w64/lib#gn;

	s#\$\(VIGRA_32\)[\\/]lib#$o4w32/lib#gn;
	s#\$\(VIGRA\)[\\/]lib#$o4w64/lib#gn;

	s#\$\(HARU_32\)#$pwd/libharu-RELEASE_2_3_0/lib-x86#gn;
	s#\$\(HARU\)#$pwd/libharu-RELEASE_2_3_0/lib-amd64#gn;

	s#\$\(WXWIN_32\)[\\/]lib[\\/]vc_dll#$pwd/lib/vc140_dll#gn;
	s#\$\(WXWIN\)[\\/]lib[\\/]vc_x64_dll#$pwd/lib/vc140_x64_dll#gn;

	s#;+#;#g;
} elsif(/<AdditionalDependencies>/) {
	s#proj\.lib;#proj_i.lib;#gn;
}

__END__
.!find .. -name "*.vcxproj" | xargs egrep -h "<Additional((Include|Library)Directories|Dependencies)>" | sort -u
